// nerdstrong polygon
$fn = 128;
date_str = "2017";
denom_str1 = "ONE";
denom_str2 = "1";
denom_str3 = "YEAR";

owidth = 2048;
oheight = 1960;
dwidth = 40.0; // desired width
dheight = dwidth*oheight/owidth;
coin_thick = 1.5;
rim_thick = 0.9;
rim_diam = 0.9;
dthick = 2.5;
body_scale = 0.8;
sc = dwidth/owidth;
bsc = dwidth*body_scale/owidth;
local_scale = owidth/dwidth;

dconnector_thick = 1.0;

main_points = [
// top left corner of weight to bar
[118,56], [150,260], [32,276], [45,346], [161,330], 
// weight outline
[196,549],[333,527],[299,313],[345,309],[379,520],[517,498],[485,296],
// beginning of arm
[556,291],[852,756],
// hip to leg
[852,1322],[782,1871],[913,1892],
// crotch to leg
[987,1321],[1077,1321],[1150,1890],[1282,1872],
// hip to arm (there is hip asymmetry here)
[1206,1276],[1206,765],[1506,296],
// weight
[1590,301],[1559,498],[1697,520],[1729,313],[1775,318],[1742,527],[1880,549],
// right bar
[1914,333],[2019,347],[2020,277],[1925,264],
// Top right corner of weight
[1958,56],[1820,34],[1786,248],[1740,244],[1774,27],[1637,5],
// inner bar/hands
[1601,231],[1515,226],[1396,219],[1288,214],[1183,210],[1069,208],[971,208],[866,209],[756,212],[664,215],[550,220],
// left weight outline
[474,226],[438,5],[301,27],[334,239],[289,244],[256,34],
// 58 pts

// main cavity
[708,282],[877,280],[1029,278],[1200,281],[1352,286],
[1126,642],[938,642],
// 7 pts
// central hex
[964,771],[1032,732],[1100,771],
[1100,849],[1032,888],[964,849],
// 6 pts

];

outl_body = [0,1,2,3,4,5,6,7,8,9,
             10,11,12,13,14,15,16,17,18,19,
             20,21,22,23,24,25,26,27,28,29,
             30,31,32,33,34,35,36,37,38,39,
             40,41,42,43,44,45,46,47,48,49,
             50,51,52,53,54,55,56,57];
outl_cavity = [58,59,60,61,62,63,64];
hex_cavity = [65,66,67,68,69,70];

cape1_points = [[790,705],[40,1025],[226,1198],[544,1198],[777,1322],[828,1311],[828,769]];
cape2_points = [[1246,749],[1225,778],[1225,1231],[1393,1197]];

cape1_connector = [[818,691],[780,711],[815,777],[815,1313],[866,1304],[870,751],[831,690]];
cape2_connector = [[1226,693],[1183,761],[1182,1235],[1252,1225],[1246,749]];
neck_connector = [[938,642],[929,662],[1136,660],[1126,642],[1087,571],[971,570]];

union() {
  ns_body();
  coin_shape();
  coin_date();
  // coin_denomination();
}

module coin_shape() {
    color([1,1,1])
      difference() {
        cylinder(d=dwidth,h=coin_thick+rim_thick);
        translate([0,0,coin_thick]) {
          cylinder(d=dwidth*rim_diam,h=2);
        }
        // translate([0,0,-coin_thick]) {
        //  cylinder(d=dwidth*rim_diam,h=coin_thick+rim_thick);
        // }
         translate([0,dwidth*.41,-1])
            cylinder(d=dwidth*.1,h=coin_thick*2);
      }
}

module coin_date() {
    color([0,0,1])
       translate([dwidth*.25,-dwidth*.22,1])
       linear_extrude(height=dthick-1, convexity=4)
                text(date_str, 
                     size=dwidth*.08,
                     font="Helvetica:style=Bold",
                     halign="center",
                     valign="center");
}

module coin_denomination() {
    color([0,0,1])
       scale([-1,1,1])
       linear_extrude(height=3, convexity=4) {
                translate([0,dwidth*.3,0])
                text(denom_str1, 
                     size=dwidth*.08,
                     font="Helvetica:style=Bold",
                     halign="center",
                     valign="center");
                text(denom_str2, 
                     size=dwidth*.4,
                     font="Iowan Old Style:style=Bold",
                     halign="center",
                     valign="center");
                translate([0,-dwidth*.3,0])
                text(denom_str3, 
                     size=dwidth*.08,
                     font="Helvetica:style=Bold",
                     halign="center",
                     valign="center");
       }
}

module ns_body() {
    translate([0,0,1])
    color([1,0,0])
      scale([bsc,-bsc,sc]) {
        translate([-owidth/2,-oheight*.42,0]) {
          linear_extrude(height=(dthick-1)*local_scale)
         union() { 
         polygon(points=main_points,paths=[outl_body,outl_cavity,hex_cavity]);
         // head
         translate([1032,453,0])
           circle(d=290);
         // bar ends
         translate([40,311,0])
           circle(d=69);
         translate([2020,311,0])
           circle(d=69);
         // hands
         translate([612,251,0])
           circle(d=130);
         translate([1461,251,0])
           circle(d=130);
         // feet
         translate([848,1883,0])
           circle(d=130);
         translate([1221,1883,0])
           circle(d=130);
         // cape 1
         polygon(cape1_points);
         polygon(cape2_points);
         }
         
         // These extrude to 3 mm
         color([.5,.5,.5])
          linear_extrude(height=dconnector_thick*local_scale)
         union() {
           polygon(cape1_connector);
           polygon(cape2_connector);
           polygon(neck_connector);
         }
         // cape 2
         // cape connector 1
         // cape connector 2
         // head/neck connector
      }
    }
}