// nerdstrong polygon
$fn = 128;
date_str = "2017";
denom_str1 = "FOUR";
denom_str2 = "4";
denom_str3 = "YEARS";

owidth = 2048;
oheight = 1960;
dwidth = 40.0; // desired width
dheight = dwidth*oheight/owidth;
coin_thick = 1.5;
rim_thick = 0.9;
rim_diam = 0.9;
dthick = 2.5;

  union() {
    coin_shape();
    coin_denomination();
  }



module coin_shape() {
    color([1,1,1])
    difference() {
        cylinder(d=dwidth,h=coin_thick+rim_thick);
        translate([0,0,coin_thick]) {
          cylinder(d=dwidth*rim_diam,h=2);
        }
        translate([0,dwidth*.4,-1])
           cylinder(d=dwidth*.1,h=dthick*2);
    }
}


text_offset = 0.29;

module coin_denomination() {
    color([0,0,1]) {
       translate([0,0,coin_thick/2]) {
       linear_extrude(height=dthick-coin_thick/2, convexity=4) {
                translate([0,dwidth*text_offset,0])
                text(denom_str1, 
                     size=dwidth*.08,
                     font="Helvetica:style=Bold",
                     halign="center",
                     valign="center");
                text(denom_str2, 
                     size=dwidth*.4,
                     font="Iowan Old Style:style=Bold",
                     halign="center",
                     valign="center");
                translate([0,-dwidth*text_offset,0])
                text(denom_str3, 
                     size=dwidth*.08,
                     font="Helvetica:style=Bold",
                     halign="center",
                     valign="center");
       }
     }
 }
}

